Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/HeuristicLab.Problems.ProgramSynthesis.csproj
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/HeuristicLab.Problems.ProgramSynthesis.csproj	(revision 14744)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/HeuristicLab.Problems.ProgramSynthesis.csproj	(revision 14745)
@@ -138,6 +138,7 @@
     <Compile Include="Push\Expressions\NameExpressions.cs" />
     <Compile Include="Push\Expressions\PopExpressions.cs" />
+    <Compile Include="Push\Expressions\PushProgram.bk.cs" />
+    <Compile Include="Push\Expressions\PushExpressions.cs" />
     <Compile Include="Push\Expressions\PushProgram.cs" />
-    <Compile Include="Push\Expressions\PushExpressions.cs" />
     <Compile Include="Push\Expressions\PushResultExpression.cs" />
     <Compile Include="Push\Expressions\RandExpressions.cs" />
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/CodeExpressions.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/CodeExpressions.cs	(revision 14744)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/CodeExpressions.cs	(revision 14745)
@@ -114,9 +114,9 @@
 
       if (isFirstList) {
-        var expand1 = first as ExecExpandExpression;
+        var expand1 = first as PushProgram;
 
         if (isSecondList) {
-          var expand2 = second as ExecExpandExpression;
-          var size = expand2.State.Expressions.Count + expand1.State.Expressions.Count;
+          var expand2 = second as PushProgram;
+          var size = expand2.State.Length + expand1.State.Length;
 
           // if size > maxPointsInProgram this expressions results in a NOOP
@@ -125,13 +125,13 @@
           result = new Expression[size];
 
-          Array.Copy(expand2.State.Expressions as Expression[], result, expand2.State.Expressions.Count);
+          Array.Copy(expand2.State, result, expand2.State.Length);
           Array.Copy(
-              expand1.State.Expressions as Expression[],
+              expand1.State,
               0,
               result,
-              expand2.State.Expressions.Count,
-              expand1.State.Expressions.Count);
+              expand2.State.Length,
+              expand1.State.Length);
         } else {
-          var size = expand1.State.Expressions.Count + 1;
+          var size = expand1.State.Length + 1;
 
           // if size > maxPointsInProgram this expressions results in a NOOP
@@ -141,10 +141,10 @@
           result[0] = second;
 
-          Array.Copy(expand1.State.Expressions as Expression[], 0, result, 1, expand1.State.Expressions.Count);
+          Array.Copy(expand1.State, 0, result, 1, expand1.State.Length);
         }
       } else if (isSecondList) {
-        var expand2 = second as ExecExpandExpression;
-
-        var size = expand2.State.Expressions.Count + 1;
+        var expand2 = second as PushProgram;
+
+        var size = expand2.State.Length + 1;
 
         // if size > maxPointsInProgram this expressions results in a NOOP
@@ -154,10 +154,10 @@
         result[0] = first;
 
-        Array.Copy(expand2.State.Expressions as Expression[], 0, result, 1, expand2.State.Expressions.Count);
+        Array.Copy(expand2.State as Expression[], 0, result, 1, expand2.State.Length);
       } else {
         result = new[] { second, first };
       }
 
-      var expression = new ExecExpandExpression(result);
+      var expression = new PushProgram(result);
 
       interpreter.CodeStack.SetTop(expression);
@@ -194,10 +194,10 @@
     public override bool Eval(IPushInterpreter interpreter) {
       if ((interpreter.CodeStack.Count == 0) ||
-          (interpreter.CodeStack.Top.GetType() != typeof(ExecExpandExpression))) return false;
-
-      var expand = interpreter.CodeStack.Top as ExecExpandExpression;
-
-      if (expand.State.IsEmpty) return false;
-      var first = expand.State.Expressions[expand.State.Expressions.Count - 1];
+          (interpreter.CodeStack.Top.GetType() != typeof(PushProgram))) return false;
+
+      var expand = interpreter.CodeStack.Top as PushProgram;
+
+      if (expand.IsEmpty) return false;
+      var first = expand.State[expand.State.Length - 1];
 
       interpreter.CodeStack.SetTop(first);
@@ -217,19 +217,19 @@
       if (interpreter.CodeStack.Count == 0) return false;
 
-      ExecExpandExpression expandExpression;
+      PushProgram expandExpression;
       var top = interpreter.CodeStack.Top;
 
       if (top.CanExpand) {
-        var expand = (ExecExpandExpression)top;
-
-        if (expand.State.IsEmpty) return false;
-        var length = expand.State.Expressions.Count - 1;
+        var expand = (PushProgram)top;
+
+        if (expand.IsEmpty) return false;
+        var length = expand.State.Length - 1;
         var newExpressions = new Expression[length];
 
-        Array.Copy((Expression[])expand.State.Expressions, 0, newExpressions, 0, length);
-
-        expandExpression = new ExecExpandExpression(newExpressions);
+        Array.Copy((Expression[])expand.State, 0, newExpressions, 0, length);
+
+        expandExpression = new PushProgram(newExpressions);
       } else {
-        expandExpression = ExecExpandExpression.Empty;
+        expandExpression = PushProgram.Empty;
       }
 
@@ -250,9 +250,9 @@
         return false;
 
-      ExecExpandExpression result;
+      PushProgram result;
 
       if (interpreter.CodeStack.Top.CanExpand) {
-        var first = (ExecExpandExpression)interpreter.CodeStack.Pop();
-        var size = first.State.Expressions.Count + 1;
+        var first = (PushProgram)interpreter.CodeStack.Pop();
+        var size = first.State.Length + 1;
 
         if (size > interpreter.Configuration.MaxPointsInProgram) return false;
@@ -260,10 +260,10 @@
         var expressions = new Expression[size];
 
-        expressions[first.State.Expressions.Count] = interpreter.CodeStack.Top;
-        Array.Copy(first.State.Expressions as Expression[], expressions, first.State.Expressions.Count);
-
-        result = new ExecExpandExpression(expressions);
+        expressions[first.State.Length] = interpreter.CodeStack.Top;
+        Array.Copy(first.State as Expression[], expressions, first.State.Length);
+
+        result = new PushProgram(expressions);
       } else {
-        result = new ExecExpandExpression(interpreter.CodeStack.Pop(), interpreter.CodeStack.Top);
+        result = new PushProgram(interpreter.CodeStack.Pop(), interpreter.CodeStack.Top);
       }
 
@@ -286,11 +286,11 @@
       if ((interpreter.CodeStack.Count < 2) ||
           (interpreter.CodeStack[interpreter.CodeStack.Count - 2].GetType() !=
-           typeof(ExecExpandExpression))) return false;
+           typeof(PushProgram))) return false;
 
       var target = interpreter.CodeStack.Pop();
       var source = interpreter.CodeStack.Top;
 
-      var container = GetContainer(source as ExecExpandExpression, target);
-      var result = container ?? ExecExpandExpression.Empty;
+      var container = GetContainer(source as PushProgram, target);
+      var result = container ?? PushProgram.Empty;
 
       interpreter.CodeStack.SetTop(result);
@@ -298,17 +298,17 @@
     }
 
-    private static ExecExpandExpression GetContainer(ExecExpandExpression current, Expression target) {
+    private static PushProgram GetContainer(PushProgram current, Expression target) {
       if (current == target)
         return null;
 
       var subContainer =
-          current.State.Expressions.Where(e => e.CanExpand)
-              .Select(e => GetContainer(e as ExecExpandExpression, target))
+          current.State.Where(e => e.CanExpand)
+              .Select(e => GetContainer(e as PushProgram, target))
               .Where(e => e != null);
 
-      var execExpandExpressions = subContainer as IList<ExecExpandExpression> ?? subContainer.ToList();
+      var execExpandExpressions = subContainer as IList<PushProgram> ?? subContainer.ToList();
       return execExpandExpressions.Any()
-          ? execExpandExpressions.OrderBy(c => c.State.Expressions.Count).LastOrDefault()
-          : current.State.Expressions.Contains(target)
+          ? execExpandExpressions.OrderBy(c => c.State.Length).LastOrDefault()
+          : current.State.Contains(target)
               ? current
               : null;
@@ -328,6 +328,6 @@
 
       var values = interpreter.CodeStack.Pop(2);
-      var second = (ExecExpandExpression)values[0];
-      var contains = second.State.Expressions.Contains(values[1]);
+      var second = (PushProgram)values[0];
+      var contains = second.State.Contains(values[1]);
 
       interpreter.BooleanStack.Push(contains);
@@ -414,7 +414,7 @@
     private void DetermineUniqueItems(Expression source, IDictionary<int, int> items) {
       if (source.CanExpand) {
-        var expand = source as ExecExpandExpression;
-
-        foreach (var e in expand.State.Expressions) {
+        var expand = source as PushProgram;
+
+        foreach (var e in expand.State) {
           var id = e.GetHashCode();
           if (!items.ContainsKey(id)) items.Add(id, 1);
@@ -445,6 +445,6 @@
         return false;
 
-      var expression = (ExecExpandExpression)interpreter.CodeStack.Top;
-      var index = (int)Math.Abs(interpreter.IntegerStack.Pop() % expression.State.TotalCount);
+      var expression = (PushProgram)interpreter.CodeStack.Top;
+      var index = (int)Math.Abs(interpreter.IntegerStack.Pop() % expression.TotalCount);
       var result = expression.GetFromTree(index);
 
@@ -536,14 +536,14 @@
 
       var source = interpreter.CodeStack[interpreter.CodeStack.Count - 2];
-      var target = (ExecExpandExpression)interpreter.CodeStack.Pop();
+      var target = (PushProgram)interpreter.CodeStack.Pop();
       var index = (int)interpreter.IntegerStack.Pop();
 
       Expression[] newExpressions;
-      if (target.State.Expressions.Count > 0) {
-        index = target.State.Expressions.Count - 1 - Math.Abs(index % target.State.Expressions.Count);
-
-        newExpressions = target.State.CopyExpressions();
+      if (target.State.Length > 0) {
+        index = target.State.Length - 1 - Math.Abs(index % target.State.Length);
+
+        newExpressions = target.CopyExpressions();
         newExpressions[index] = source.CanExpand
-            ? ((ExecExpandExpression)source).Copy()
+            ? ((PushProgram)source).Copy()
             : source;
       } else {
@@ -551,5 +551,5 @@
       }
 
-      var result = new ExecExpandExpression(newExpressions);
+      var result = new PushProgram(newExpressions);
       interpreter.CodeStack.SetTop(result);
 
@@ -573,5 +573,5 @@
 
       if (expression.CanExpand)
-        count = ((ExecExpandExpression)expression).State.Expressions.Count;
+        count = ((PushProgram)expression).State.Length;
 
       interpreter.IntegerStack.Push(count);
@@ -591,5 +591,5 @@
       var first = interpreter.CodeStack.Pop();
       var second = interpreter.CodeStack.Top;
-      var expandExpression = new ExecExpandExpression(second, first);
+      var expandExpression = new PushProgram(second, first);
 
       interpreter.CodeStack.SetTop(expandExpression);
@@ -611,5 +611,5 @@
 
       var contains = expressions[1].CanExpand
-          ? ((ExecExpandExpression)expressions[1]).State.Expressions.Contains(expressions[0])
+          ? ((PushProgram)expressions[1]).State.Contains(expressions[0])
           : expressions[1].Equals(expressions[0]);
 
@@ -636,13 +636,13 @@
 
       if (expression.CanExpand) {
-        var subExpression = (ExecExpandExpression)expression;
-
-        if (subExpression.State.IsEmpty) {
-          nthExpression = ExecExpandExpression.Empty;
+        var subExpression = (PushProgram)expression;
+
+        if (subExpression.IsEmpty) {
+          nthExpression = PushProgram.Empty;
         } else {
-          var index = (int)(subExpression.State.Expressions.Count - 1 -
-                             Math.Abs(n % subExpression.State.Expressions.Count));
-
-          nthExpression = subExpression.State.Expressions[index];
+          var index = (int)(subExpression.State.Length - 1 -
+                             Math.Abs(n % subExpression.State.Length));
+
+          nthExpression = subExpression.State[index];
         }
       } else {
@@ -672,13 +672,13 @@
       var expression = interpreter.CodeStack.Top;
 
-      Expression nthExpression = null;
+      Expression nthExpression;
 
       if (expression.CanExpand) {
-        var subExpressions = ((ExecExpandExpression)expression).State.Expressions;
-
-        if (subExpressions.Count < 2) {
-          nthExpression = ExecExpandExpression.Empty;
+        var subExpressions = ((PushProgram)expression).State;
+
+        if (subExpressions.Length < 2) {
+          nthExpression = PushProgram.Empty;
         } else {
-          var index = (int)(subExpressions.Count - 2 - Math.Abs(n % (subExpressions.Count - 1)));
+          var index = (int)(subExpressions.Length - 2 - Math.Abs(n % (subExpressions.Length - 1)));
 
           nthExpression = subExpressions[index];
@@ -702,5 +702,5 @@
       if (interpreter.CodeStack.Count == 0) return false;
 
-      var result = interpreter.CodeStack.Pop().Equals(ExecExpandExpression.Empty);
+      var result = interpreter.CodeStack.Pop().Equals(PushProgram.Empty);
       interpreter.BooleanStack.Push(result);
 
@@ -724,7 +724,7 @@
       var position = -1;
       if (first.CanExpand) {
-        var expand = (ExecExpandExpression)first;
-        position = expand.State.Expressions.Count - 1
-                   - Array.FindIndex((Expression[])expand.State.Expressions, e => e.Equals(second));
+        var expand = (PushProgram)first;
+        position = expand.State.Length - 1
+                   - Array.FindIndex((Expression[])expand.State, e => e.Equals(second));
       } else if (first.Equals(second)) {
         position = 0;
@@ -748,5 +748,5 @@
       var expression = interpreter.CodeStack.Pop();
       var points = expression.CanExpand
-          ? ((ExecExpandExpression)expression).State.Expressions.Count
+          ? ((PushProgram)expression).State.Length
           : 1;
 
@@ -767,19 +767,19 @@
     public override bool Eval(IPushInterpreter interpreter) {
       if ((interpreter.CodeStack.Count < 3) || (interpreter.CodeStack.Top.GetType() !=
-                                                typeof(ExecExpandExpression))) return false;
+                                                typeof(PushProgram))) return false;
 
       var expressions = interpreter.CodeStack.Pop(2);
       var third = interpreter.CodeStack.Top;
       var second = expressions[0];
-      var first = expressions[1] as ExecExpandExpression;
-      var newExpressions = new Expression[first.State.Expressions.Count];
-
-      for (var i = 0; i < first.State.Expressions.Count; i++)
-        newExpressions[i] = first.State.Expressions[i].Equals(third)
+      var first = expressions[1] as PushProgram;
+      var newExpressions = new Expression[first.State.Length];
+
+      for (var i = 0; i < first.State.Length; i++)
+        newExpressions[i] = first.State[i].Equals(third)
             ? second
             /* no cloning needed here because first is removed and therefore newExpression is the only container of sub expressions */
-            : first.State.Expressions[i];
-
-      var result = new ExecExpandExpression(newExpressions);
+            : first.State[i];
+
+      var result = new PushProgram(newExpressions);
 
       interpreter.CodeStack.SetTop(result);
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/ExecExpressions.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/ExecExpressions.cs	(revision 14744)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/ExecExpressions.cs	(revision 14745)
@@ -1,6 +1,3 @@
 ﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
-  using System;
-  using System.Collections.Generic;
-  using System.Linq;
 
   using HeuristicLab.Problems.ProgramSynthesis.Push.Attributes;
@@ -8,69 +5,4 @@
 
   using Interpreter;
-
-  public class ExecExpandExpression : StatefulExpression<PushProgram> {
-    public static readonly ExecExpandExpression Empty = new ExecExpandExpression(PushProgram.Empty);
-
-    public ExecExpandExpression(PushProgram program)
-      : base(program) {
-    }
-
-    public ExecExpandExpression(params Expression[] state) : this(new PushProgram(state)) {
-    }
-
-    public ExecExpandExpression(IEnumerable<Expression> state) : this(state.ToArray()) {
-      // TODO: lazy evaluation of ToArray()
-    }
-
-    public override string StringRepresentation { get { return this.State.ToString(); } }
-
-    public ExecExpandExpression Copy() {
-      // as the empty list is a static stateless expression, no copy required
-      return ReferenceEquals(this, Empty) || this.State.IsEmpty
-        ? Empty
-        : new ExecExpandExpression(this.State.Copy());
-    }
-
-    public override bool Eval(IPushInterpreter interpreter) {
-      interpreter.ExecStack.Push(this.State.Expressions);
-      return true;
-    }
-
-    /// <summary>
-    ///     Returns the element with the given index whereby the tree is indexed in depth first manner
-    /// </summary>
-    /// <param name="index">The index of the required element</param>
-    /// <returns>The required element</returns>
-    public Expression GetFromTree(int index) {
-      return GetFromTree(index, (root, parent, child, childIndex, parentIndex) => child);
-    }
-
-    /// <returns>The required element</returns>
-    public T GetFromTree<T>(int index,
-        Func<ExecExpandExpression, ExecExpandExpression, Expression, int, int, T> resolver) {
-      return GetFromTree(index, 0, null, resolver);
-    }
-
-    private T GetFromTree<T>(int index, int parentIndex, ExecExpandExpression parent,
-        Func<ExecExpandExpression, ExecExpandExpression, Expression, int, int, T> resolver) {
-      if (index == 0) return resolver(parent, parent, this, 0, parentIndex);
-
-      var min = State.Expressions.Count - 1;
-      var max = 0;
-      var mid = (min + max) / 2;
-
-      while ((max <= min) && (this.State.TreeIndex[mid] != index)) {
-        if (this.State.TreeIndex[mid] > index) max = mid + 1;
-        else min = mid - 1;
-
-        mid = (min + max) / 2;
-      }
-
-      return this.State.TreeIndex[mid] == index
-          ? resolver(parent, this, State.Expressions[mid], mid, parentIndex)
-          : (State.Expressions[mid + 1] as ExecExpandExpression).GetFromTree(index - this.State.TreeIndex[mid + 1], mid + 1,
-              this, resolver);
-    }
-  }
 
   /// <summary>
@@ -110,5 +42,5 @@
       var execYExpression = ExpressionTable.GetStatelessExpression<ExecYExpression>();
 
-      var result = new ExecExpandExpression(top, execYExpression);
+      var result = new PushProgram(top, execYExpression);
 
       interpreter.ExecStack.SetTop(result);
@@ -149,5 +81,5 @@
       var c = interpreter.ExecStack.Top;
 
-      var newTop = new ExecExpandExpression(c, b);
+      var newTop = new PushProgram(c, b);
 
       interpreter.ExecStack.SetTop(newTop);
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/Expression.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/Expression.cs	(revision 14744)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/Expression.cs	(revision 14745)
@@ -8,5 +8,5 @@
 
   public abstract class Expression {
-    public bool CanExpand { get { return this.GetType() == typeof(ExecExpandExpression); } }
+    public bool CanExpand { get { return this.GetType() == typeof(PushProgram); } }
 
     public static readonly IReadOnlyCollection<Expression> EmptyContainer = new Expression[0];
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/ExpressionTable.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/ExpressionTable.cs	(revision 14744)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/ExpressionTable.cs	(revision 14745)
@@ -123,5 +123,5 @@
     }
 
-    public static ExecExpandExpression GetProgram(int[] index) {
+    public static PushProgram GetProgram(int[] index) {
       var expressions = new Expression[index.Length];
 
@@ -130,6 +130,5 @@
       }
 
-      var program = new PushProgram(expressions);
-      return new ExecExpandExpression(program);
+      return new PushProgram(expressions);
     }
 
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PushProgram.bk.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PushProgram.bk.cs	(revision 14745)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PushProgram.bk.cs	(revision 14745)
@@ -0,0 +1,202 @@
+﻿//using System.Collections.Generic;
+
+//namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
+//  using System.Diagnostics;
+//  using System.Linq;
+
+//  public class PushProgram {
+
+//    private const string Prefix = "(";
+//    private const string PrefixReduced = "[";
+//    private const string Postfix = ")";
+//    private const string PostfixReduced = "]";
+//    private const string Delimiter = " ";
+
+//    public static readonly PushProgram Empty = new PushProgram(new Expression[0]);
+
+//    public readonly IReadOnlyList<Expression> Expressions;
+//    public bool IsEmpty { get; private set; }
+
+//    public PushProgram(Expression[] expressions) {
+//      this.Expressions = expressions;
+//      this.IsEmpty = expressions.Length == 0;
+//    }
+
+//    private string stringRepresentation;
+//    private string StringRepresentation
+//    {
+//      get
+//      {
+//        if (string.IsNullOrEmpty(stringRepresentation))
+//          stringRepresentation = BuildString();
+//        return stringRepresentation;
+//      }
+//    }
+
+//    private int depth = -1;
+//    private int Depth
+//    {
+//      get
+//      {
+//        if (depth == -1) depth = CalcDepth();
+//        return depth;
+//      }
+//    }
+
+//    private int[] treeIndex = null;
+//    public int[] TreeIndex
+//    {
+//      get
+//      {
+//        return this.treeIndex ?? (this.treeIndex = this.BuildTreeIndex());
+//      }
+//    }
+
+//    private int hashCode;
+//    private int HashCode
+//    {
+//      get
+//      {
+//        if (hashCode == default(int)) hashCode = HashExpressions();
+//        return hashCode;
+//      }
+//    }
+
+//    public override int GetHashCode() {
+//      return HashCode;
+//    }
+
+//    public override string ToString() {
+//      return this.StringRepresentation;
+//    }
+
+//    /// <summary>
+//    /// Returns the amount of elements in the whole tree
+//    /// </summary>
+//    /// <returns></returns>
+//    public int TotalCount
+//    {
+//      get
+//      {
+//        return this.IsEmpty
+//            ? 1
+//            // + 1 because "this" is also counted
+//            : TreeIndex[0] + 1;
+//      }
+//    }
+
+//    public IEnumerable<Expression> DepthFirst() {
+//      foreach (var expr in this.Expressions) {
+//        if (expr.CanExpand) {
+//          var expandExpr = (PushProgram)expr;
+
+//          foreach (var sub in expandExpr.State.DepthFirst())
+//            yield return sub;
+//        } else yield return expr;
+//      }
+//    }
+
+//    public PushProgram Copy() {
+//      return IsEmpty ? this : new PushProgram((Expression[])Expressions) {
+//        stringRepresentation = this.stringRepresentation,
+//        hashCode = this.hashCode,
+//        depth = this.depth,
+//        treeIndex = this.treeIndex
+//      };
+//    }
+
+//    public Expression[] CopyExpressions() {
+//      var copy = new Expression[this.Expressions.Count];
+//      ((Expression[])this.Expressions).CopyTo(copy, Expressions.Count);
+
+//      return copy;
+//    }
+
+//    private int CalcDepth() {
+//      //var subExpressions = Expressions.Where(e => e.CanExpand);
+//      //var depth = subExpressions.Any()
+//      //    ? subExpressions.Select(e => e as PushProgram).Max(e => e.State.Depth) + 1
+//      //    : 1;
+
+//      ////return depth;
+
+//      var maxDepth = 1;
+//      for (var i = 0; i < Expressions.Count; i++) {
+//        var expression = Expressions[i];
+//        if (!expression.CanExpand) continue;
+//        var expandExpression = (PushProgram)expression;
+
+//        if (expandExpression.State.Depth > maxDepth)
+//          maxDepth = expandExpression.State.Depth;
+//      }
+
+//      return maxDepth + 1;
+//    }
+
+//    private string BuildString() {
+//      // prevent too big string
+//      return this.TotalCount > 50
+//        ? PrefixReduced + this.Expressions.Count + PostfixReduced
+//        : Prefix + string.Join(Delimiter, this.Expressions.Where(e => !string.IsNullOrWhiteSpace(e.StringRepresentation))) + Postfix;
+//    }
+
+//    private int[] BuildTreeIndex() {
+//      var local_treeIndex = new int[this.Expressions.Count];
+
+//      var next = 1;
+
+//      for (var i = this.Expressions.Count - 1; i >= 0; i--) {
+//        var subExpression = this.Expressions[i];
+
+//        local_treeIndex[i] = next;
+
+//        if (subExpression.CanExpand) {
+//          next += ((PushProgram)subExpression).State.TotalCount;
+//        } else {
+//          next++;
+//        }
+//      }
+
+//      return local_treeIndex;
+//    }
+
+//    private int HashExpressions() {
+//      var hash = 19 * 31 + this.GetType().FullName.GetHashCode();
+
+//      for (var i = 0; i < this.Expressions.Count; i++) {
+//        hash = hash * 31 + this.Expressions[i].GetHashCode();
+//      }
+
+//      return hash;
+//    }
+
+//    private static void CheckIfNested(int level, PushProgram target, PushProgram current,
+//        IList<PushProgram> visited) {
+//      if (visited.Any(x => ReferenceEquals(x, current)))
+//        Debugger.Break();
+
+//      visited.Add(current);
+//      if (level <= 0) {
+//        // hirarchy depth > level
+//        Debugger.Break();
+//        return;
+//      }
+
+//      for (var i = 0; i < current.State.Expressions.Count; i++) {
+//        if (current.State.Expressions[i].CanExpand)
+//          continue;
+
+//        var subExpression = current.State.Expressions[i] as PushProgram;
+
+//        if (ReferenceEquals(target, subExpression)) {
+//          // Endless recursion dedected
+//          Debugger.Break();
+//        }
+
+//        CheckIfNested(level - 1, target, subExpression, visited);
+//      }
+
+//      visited.RemoveAt(visited.Count - 1);
+//    }
+//  }
+//}
